# Классы, инкапсулирующие SQL запросы — Query
**Query** — позволяет частично инкапсулировать различные SQL запрос-ы, расширять и модифицировать их. Почему именно частично? Дело в том, что мы не ставили перед собой задачу обеспечить полную переносимость SQL-кода между различными базами данных. Текущая реализация Query - это результат небольших рефакторингов, направленных всего лишь на повышение уровня повторного использования кода, связанного с формированием и манипуляцией SQL-кода. Поэтому для использования Query классов знание SQL - обязательно.

Список классов, входящих в подсистему:

Класс | Назначение
------|-----------
**Базовые классы** |
[lmb_template_query](./lmb_template_query.md) | Базовый класс для всех классов подсистемы Query
[lmbCriteriaQuery](./lmb_criteria_query.md) | Абстрактный класс. Реализует добавление условий в запросы
[lmb_select_raw_query](./lmb_select_raw_query.md) | Базовый класс для формирования SQL-запросов для выборки данных. Является родителем lmb_select_query
**Конечные классы** |
[lmb_select_query](./lmb_select_query.md) | При помощи этого класса формируется SQL-запросы для выборки данных
[lmb_insert_query](./lmb_insert_query.md) | Реализует запросы по вставке записей
[lmb_bulk_insert_query](./lmb_bulk_insert_query.md)  | Реализует запросы по вставке большого количества записей
[lmb_insert_on_duplicate_update_query](./lmb_insert_on_duplicate_update_query.md) | Реализует запросы по вставке записей, при совпадении уникального индекса происходит обновление данных
[lmb_update_query](./lmb_update_query.md) | Реализует запросы по обновлению записей
[lmb_delete_query](./lmb_delete_query.md) | Инкапсулирует запросы для удаления записей
