# Пример 1. Создание CRUD приложения с использованием Limb3
## Цели данного примера

* Показать процесс создания проекта с нуля на базе Limb3
* Показать основы создания веб-приложений на Limb3 с использованием пакета WEB_APP
* Дать начальные знания по шаблонной системе MACRO, показать способы использования наиболее распространенных тегов шаблонной системы.

Код данного примера можно найти в разделе c примерами использования Limb3

### Системные требования

* Операционная система: *nix, Windows 98/ME/2000/XP
* Веб-сервер: Apache 1.3+ (с подключенным модулем mod_rewrite), nginx (в связке с php-fpm)
* PHP: <= 5.3 (использовать [Limb2014.1](https://github.com/limb-php-framework/limb/tree/Limb2014.1)), PHP 5.5 (использовать [master](https://github.com/limb-php-framework/limb)),
* Поддерживаемые базы данных: [MySQL](http://www.mysql.com/) 4.1+, [PostgreSQL](http://www.postgresql.org/) 8.2+, [Oracle](http://www.oracle.com/index.html) (OCI8)

#### Настройки РНР

* zend.ze1_compatibility_mode = off

[Подробнее о настройке веб-сервера, для типичной схемы работы с приложением на базе пакета WEB_APP или CMS](../../../web_app/docs/ru/web_app/app_installation.md).

## Исходный код
Limb3, как фреймворк, поставляется в виде отдельных пакетов, например, CORE, ACTIVE_RECORD, WEB_APP, DBAL и т.д. Мы предполагаем, что вы уже прочитали статью о том [как работать с пакетами Limb](../packages_architecture.md).

Для выполнения данного примера нам необходим пакет WEB_APP, а также пакеты, от которых он зависит; этот список достаточно большой, поэтому мы рекомендуем получить сразу все доступные пакеты. Есть [несколько способов получить исходные коды Limb3](../how_to_download.md) — просто выберите тот, что вам подходит больше всего.

## Далее

1. [Шаг 1. Создание каркаса проекта и запуск приложения](./basic/step1.md)
2. [Шаг 2. Вывод новостей через шаблон](./basic/step2.md)
3. [Шаг 3. Добавление форм для создания, редактирования новостей. Валидация данных. Удаление новостей](./basic/step3.md)
4. [Шаг 4. Оптимизация шаблонов. Добавление постраничного вывода](./basic/step4.md)
5. [Шаг 5. Финальные штрихи(cортировка, отображение новости целиком, пять свежих новостей на главной странице)](./basic/step5.md)
6. [Шаг 6. Создание RSS-feed новостной ленты](./basic/step6.md)
7. [Шаг 7. Рекомендации по дальнейшему изучению](./basic/step7.md)
