# Работа с мультибайтным контентом (UTF-8)
Перед прочтением стоит ознакомиться:

* [http://www.phpwact.org/php/i18n/charsets](http://www.phpwact.org/php/i18n/charsets)
* [http://www.phpwact.org/php/i18n](http://www.phpwact.org/php/i18n)

Для работы с мультибайтовым контентом в Limb есть набор функций, использующихся вместо стандартных, например, **lmb_strlen()**, **lmb_ltrim()**, **lmb_rtrim()**, **lmb_strtolower()** и т.д. То есть название оригинальной функции для работы со строками с префиксом в виде «lmb_». Список этих функций находится limb/i18n/src/charset/driver.inc.php.

Реализация этих функций делегируется текущему драйверу, который работает со строками. По-умолчанию используется один из UTF-8 драйверов. Автоматическая настройка того или иного драйвера осуществляется в скрипте **i18n/utf8.inc.php**, который необходимо подключить перед началом работы с мультибайтным контентом.

По-умолчанию в качества мультибайтового драйвера подключается драйвер lmbUTF8MbstringDriver на основе PHP расширения mbstring. Если данное расширение не подключено, тогда используется базовый lmbUTF8BaseDriver. Доступен также lmbUTF8IconvDriver, работающий на основе функций PHP расширения iconv.

Функции для работы с мультибайтовыми строками используются в [фильтрах пакета I18N](./tags_and_filters.md).

Для удобства еревода контента из кодировки win1251 в UTF-8 и наоборот есть дополнительный функции (находятся также в utf8.inc.php):

* **lmb_win1251_to_utf8($str)**
* **lmb_utf8_to_win1251($str)**
