# Тег {{select_options_export}}
## Описание
Позволяет преобразовывать различные источники данных (итераторы или обычные массивы) в форму, понятную [тегу {{select}}](./select_tag.md) для формирования списка тегов <option>.

Этот тег используется в случае, например, если список опций нужно построить на основе записей из таблицы базы данных. Результат работы этого тега — это просто переменная, указанная при помощи атрибута **to**, которая будет содержать массив вида **array(option_key ⇒ option_text, option_key ⇒ option_text, ...)**. Этот массив будет построен на основе источника, который указывается при помощи атрибута **from**. То, какие поля будут использоваться в качестве option_key и option_text указывается при помощи атрибутов **key_field** и **text_field**.

## Синтаксис

    {{select_options_export to='$options_var' from="$source_var" key_field='key_field' text_field='text_field'/}}

## Область применения
Обычно (не обязательно) внутри [тега {{form}}](./form_tag.md) и совместо с [тегом {{select}}](./select_tag.md).

## Атрибуты
* **to** — имя переменной, куда тег положит сформированный массив опций.
* **from** — имя переменной — источника первоначальных данных, из которых нужно сформировать массив опций.
* **key_field** — название поля, значение которого будет использоваться как идентификатор опции.
* **text_field** — название поля, значение которого будет использоваться как название опции.

## Содержимое
Нет.

## Пример использования

    <?
     $teams = array(array('id' => '1', 'title' => 'Spartak'),
                    array('id' => '2', 'title' => 'Dinamo'),
                    array('id' => '3', 'title' => 'Zenit'));
    ?>
 
    {{select_options_export from="$teams" to="$teams_as_options" key_field="id" text_field="title"/}}
 
    {{select id='team_id' name='team_id' options="$teams_as_options"}}
     {{option prepend="true" value='0'}}Выберите команду{{/option}}
    {{/select}}
